	cpu LMM
	.module subroutines.c
	.area text(rom, con, rel)
	.dbfile ./subroutines.c
	.dbfunc e ProcessRxByte _ProcessRxByte fV
;   VelocityCode -> X+0
;            Cmd -> X-6
;         RxByte -> X-4
_ProcessRxByte::
	.dbline -1
	push X
	mov X,SP
	add SP,3
	.dbline 7
; #include <m8c.h>        // part specific constants and macros
; #include "PSoCAPI.h"    // PSoC API definitions for all User Modules
; #include <stdlib.h>
; #include "motorcontroller.h"
; 
; void ProcessRxByte(BYTE RxByte, CmdStruct * Cmd)
; {
	.dbline 10
; 	BYTE	VelocityCode;
; 
; 	Cmd->MotionType = ((RxByte & 0x20) >> 5);
	mov REG[0xd0],>__r0
	mov A,[X-4]
	and A,32
	asr A
	asr A
	asr A
	asr A
	asr A
	and A,7
	mov [__r0],A
	mov A,[X-5]
	mov [__r3],A
	mov A,[X-6]
	mov REG[0xd5],A
	mov A,[__r0]
	mvi [__r3],A
	.dbline 11
; 	VelocityCode = ((RxByte & 0x18) >> 3);
	mov A,[X-4]
	and A,24
	asr A
	asr A
	asr A
	and A,31
	mov [X+0],A
	.dbline 12
; 	if (RxByte & LF_ON)
	tst [X-4],64
	jz L5
	.dbline 13
; 		Cmd->LineFollow = 1;
	mov A,[X-5]
	add A,7
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,1
	mvi [__r1],A
	xjmp L6
L5:
	.dbline 15
; 		else
; 		Cmd->LineFollow = 0;
	mov REG[0xd0],>__r0
	mov A,[X-5]
	add A,7
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
L6:
	.dbline 18
; 
; 
; 	switch (VelocityCode)
	mov A,[X+0]
	mov [X+2],A
	mov [X+1],0
	cmp [X+1],0
	jnz X1
	cmp [X+2],0
	jz L10
X1:
	cmp [X+1],0
	jnz X2
	cmp [X+2],1
	jz L11
X2:
	cmp [X+1],0
	jnz X3
	cmp [X+2],2
	jz L12
X3:
	cmp [X+1],0
	jnz X4
	cmp [X+2],3
	jz L13
X4:
	xjmp L7
X0:
	.dbline 19
; 	{
L10:
	.dbline 21
; 	   	case 0x0:
; 	   		Cmd->Velocity = 0;
	mov REG[0xd0],>__r0
	mov A,[X-5]
	add A,1
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	mvi [__r1],A
	.dbline 22
; 	   		Cmd->VP6 = 0;
	mov A,[X-5]
	add A,12
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	mvi [__r1],A
	.dbline 23
; 	   		Cmd->VP5 = 0;
	mov A,[X-5]
	add A,14
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	mvi [__r1],A
	.dbline 24
; 	   		Cmd->VP4 = 0;
	mov A,[X-5]
	add A,16
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	mvi [__r1],A
	.dbline 25
; 	   		Cmd->VP3 = 0;
	mov A,[X-5]
	add A,18
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	mvi [__r1],A
	.dbline 26
; 	   		Cmd->VP2 = 0;
	mov A,[X-5]
	add A,20
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	mvi [__r1],A
	.dbline 27
; 	   		Cmd->VP1 = 0;
	mov A,[X-5]
	add A,22
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	mvi [__r1],A
	.dbline 28
; 	   		Cmd->VS1 = 0;
	mov A,[X-5]
	add A,24
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	mvi [__r1],A
	.dbline 29
; 	   		Cmd->VS2 = 0;
	mov A,[X-5]
	add A,26
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	mvi [__r1],A
	.dbline 30
; 	   		Cmd->VS3 = 0;
	mov A,[X-5]
	add A,28
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	mvi [__r1],A
	.dbline 31
; 	   		Cmd->VS4 = 0;
	mov A,[X-5]
	add A,30
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	mvi [__r1],A
	.dbline 32
; 	   		Cmd->VS5 = 0;
	mov A,[X-5]
	add A,32
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	mvi [__r1],A
	.dbline 33
; 	   		Cmd->VS6 = 0;
	mov A,[X-5]
	add A,34
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	mvi [__r1],A
	.dbline 34
; 	    break;
	xjmp L8
L11:
	.dbline 37
; 
; 	   	case 0x1:
; 	   		Cmd->Velocity = SLOW;
	mov REG[0xd0],>__r0
	mov A,[X-5]
	add A,1
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	mov A,80
	mvi [__r1],A
	.dbline 38
; 	   		Cmd->VP6 = SLOWP6;
	mov A,[X-5]
	add A,12
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	mov A,-76
	mvi [__r1],A
	.dbline 39
; 	   		Cmd->VP5 = SLOWP5;
	mov A,[X-5]
	add A,14
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	mov A,-86
	mvi [__r1],A
	.dbline 40
; 	   		Cmd->VP4 = SLOWP4;
	mov A,[X-5]
	add A,16
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	mov A,-96
	mvi [__r1],A
	.dbline 41
; 	   		Cmd->VP3 = SLOWP3;
	mov A,[X-5]
	add A,18
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	mov A,-106
	mvi [__r1],A
	.dbline 42
; 	   		Cmd->VP2 = SLOWP2;
	mov A,[X-5]
	add A,20
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	mov A,-116
	mvi [__r1],A
	.dbline 43
; 	   		Cmd->VP1 = SLOWP1;
	mov A,[X-5]
	add A,22
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	mov A,-126
	mvi [__r1],A
	.dbline 44
; 	   		Cmd->VS1 = SLOWS1;
	mov A,[X-5]
	add A,24
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	mov A,125
	mvi [__r1],A
	.dbline 45
; 	   		Cmd->VS2 = SLOWS2;
	mov A,[X-5]
	add A,26
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	mov A,125
	mvi [__r1],A
	.dbline 46
; 	   		Cmd->VS3 = SLOWS3;
	mov A,[X-5]
	add A,28
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	mov A,125
	mvi [__r1],A
	.dbline 47
; 	   		Cmd->VS4 = SLOWS4;
	mov A,[X-5]
	add A,30
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	mov A,125
	mvi [__r1],A
	.dbline 48
; 	   		Cmd->VS5 = SLOWS5;
	mov A,[X-5]
	add A,32
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	mov A,125
	mvi [__r1],A
	.dbline 49
; 	   		Cmd->VS6 = SLOWS6;
	mov A,[X-5]
	add A,34
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	mov A,125
	mvi [__r1],A
	.dbline 50
; 	    break;
	xjmp L8
L12:
	.dbline 53
; 
; 	   	case 0x2:
; 	   		Cmd->Velocity = MEDIUM;
	mov REG[0xd0],>__r0
	mov A,[X-5]
	add A,1
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	mov A,-56
	mvi [__r1],A
	.dbline 54
; 	   		Cmd->VP6 = MEDIUMP6;
	mov A,[X-5]
	add A,12
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,1
	mvi [__r1],A
	mov A,-112
	mvi [__r1],A
	.dbline 55
; 	   		Cmd->VP5 = MEDIUMP5;
	mov A,[X-5]
	add A,14
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,1
	mvi [__r1],A
	mov A,94
	mvi [__r1],A
	.dbline 56
; 	   		Cmd->VP4 = MEDIUMP4;
	mov A,[X-5]
	add A,16
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,1
	mvi [__r1],A
	mov A,44
	mvi [__r1],A
	.dbline 57
; 	   		Cmd->VP3 = MEDIUMP3;
	mov A,[X-5]
	add A,18
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,1
	mvi [__r1],A
	mov A,19
	mvi [__r1],A
	.dbline 58
; 	   		Cmd->VP2 = MEDIUMP2;
	mov A,[X-5]
	add A,20
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	mov A,-6
	mvi [__r1],A
	.dbline 59
; 	   		Cmd->VP1 = MEDIUMP1;
	mov A,[X-5]
	add A,22
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	mov A,-31
	mvi [__r1],A
	.dbline 60
; 	   		Cmd->VS1 = MEDIUMS1;
	mov A,[X-5]
	add A,24
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	mov A,-66
	mvi [__r1],A
	.dbline 61
; 	   		Cmd->VS2 = MEDIUMS2;
	mov A,[X-5]
	add A,26
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	mov A,-76
	mvi [__r1],A
	.dbline 62
; 	   		Cmd->VS3 = MEDIUMS3;
	mov A,[X-5]
	add A,28
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	mov A,-86
	mvi [__r1],A
	.dbline 63
; 	   		Cmd->VS4 = MEDIUMS4;
	mov A,[X-5]
	add A,30
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	mov A,-96
	mvi [__r1],A
	.dbline 64
; 	   		Cmd->VS5 = MEDIUMS5;
	mov A,[X-5]
	add A,32
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	mov A,-106
	mvi [__r1],A
	.dbline 65
; 	   		Cmd->VS6 = MEDIUMS6;
	mov A,[X-5]
	add A,34
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	mov A,-116
	mvi [__r1],A
	.dbline 66
; 	    break;
	xjmp L8
L13:
	.dbline 69
; 
; 	   	case 0x3:
; 	   		Cmd->Velocity = FAST;
	mov REG[0xd0],>__r0
	mov A,[X-5]
	add A,1
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,1
	mvi [__r1],A
	mov A,-112
	mvi [__r1],A
	.dbline 70
; 	   		Cmd->VP6 = FASTP6;
	mov A,[X-5]
	add A,12
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,1
	mvi [__r1],A
	mov A,-82
	mvi [__r1],A
	.dbline 71
; 	   		Cmd->VP5 = FASTP5;
	mov A,[X-5]
	add A,14
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,1
	mvi [__r1],A
	mov A,-87
	mvi [__r1],A
	.dbline 72
; 	   		Cmd->VP4 = FASTP4;
	mov A,[X-5]
	add A,16
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,1
	mvi [__r1],A
	mov A,-92
	mvi [__r1],A
	.dbline 73
; 	   		Cmd->VP3 = FASTP3;
	mov A,[X-5]
	add A,18
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,1
	mvi [__r1],A
	mov A,-97
	mvi [__r1],A
	.dbline 74
; 	   		Cmd->VP2 = FASTP2;
	mov A,[X-5]
	add A,20
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,1
	mvi [__r1],A
	mov A,-102
	mvi [__r1],A
	.dbline 75
; 	   		Cmd->VP1 = FASTP1;
	mov A,[X-5]
	add A,22
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,1
	mvi [__r1],A
	mov A,-107
	mvi [__r1],A
	.dbline 76
; 	   		Cmd->VS1 = FASTS1;
	mov A,[X-5]
	add A,24
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,1
	mvi [__r1],A
	mov A,-117
	mvi [__r1],A
	.dbline 77
; 	   		Cmd->VS2 = FASTS2;
	mov A,[X-5]
	add A,26
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,1
	mvi [__r1],A
	mov A,-122
	mvi [__r1],A
	.dbline 78
; 	   		Cmd->VS3 = FASTS3;
	mov A,[X-5]
	add A,28
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,1
	mvi [__r1],A
	mov A,-122
	mvi [__r1],A
	.dbline 79
; 	   		Cmd->VS4 = FASTS4;
	mov A,[X-5]
	add A,30
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,1
	mvi [__r1],A
	mov A,-122
	mvi [__r1],A
	.dbline 80
; 	   		Cmd->VS5 = FASTS5;
	mov A,[X-5]
	add A,32
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,1
	mvi [__r1],A
	mov A,-122
	mvi [__r1],A
	.dbline 81
; 	   		Cmd->VS6 = FASTS6;
	mov A,[X-5]
	add A,34
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,1
	mvi [__r1],A
	mov A,-122
	mvi [__r1],A
	.dbline 82
; 	    break;
	xjmp L8
L7:
	.dbline 85
; 
; 	   	default:
; 	   		Cmd->Velocity = 0;
	mov REG[0xd0],>__r0
	mov A,[X-5]
	add A,1
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	mvi [__r1],A
	.dbline 86
; 	   		Cmd->VP6 = 0;
	mov A,[X-5]
	add A,12
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	mvi [__r1],A
	.dbline 87
; 	   		Cmd->VP5 = 0;
	mov A,[X-5]
	add A,14
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	mvi [__r1],A
	.dbline 88
; 	   		Cmd->VP4 = 0;
	mov A,[X-5]
	add A,16
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	mvi [__r1],A
	.dbline 89
; 	   		Cmd->VP3 = 0;
	mov A,[X-5]
	add A,18
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	mvi [__r1],A
	.dbline 90
; 	   		Cmd->VP2 = 0;
	mov A,[X-5]
	add A,20
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	mvi [__r1],A
	.dbline 91
; 	   		Cmd->VP1 = 0;
	mov A,[X-5]
	add A,22
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	mvi [__r1],A
	.dbline 92
; 	   		Cmd->VS1 = 0;
	mov A,[X-5]
	add A,24
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	mvi [__r1],A
	.dbline 93
; 	   		Cmd->VS2 = 0;
	mov A,[X-5]
	add A,26
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	mvi [__r1],A
	.dbline 94
; 	   		Cmd->VS3 = 0;
	mov A,[X-5]
	add A,28
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	mvi [__r1],A
	.dbline 95
; 	   		Cmd->VS4 = 0;
	mov A,[X-5]
	add A,30
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	mvi [__r1],A
	.dbline 96
; 	   		Cmd->VS5 = 0;
	mov A,[X-5]
	add A,32
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	mvi [__r1],A
	.dbline 97
; 	   		Cmd->VS6 = 0;
	mov A,[X-5]
	add A,34
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	mvi [__r1],A
	.dbline 98
; 	}//End switch
L8:
	.dbline 100
; 
; 	if (Cmd->MotionType == TRANS)
	mov REG[0xd0],>__r0
	mov A,[X-5]
	mov [__r1],A
	mov A,[X-6]
	mov REG[0xd4],A
	mvi A,[__r1]
	cmp A,0
	jnz L14
	.dbline 101
; 	{
	.dbline 102
; 		if (RxByte & 0x04)
	tst [X-4],4
	jz L16
	.dbline 103
; 		{
	.dbline 104
; 			Cmd->Direction = BWD;
	mov A,[X-5]
	add A,3
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,1
	mvi [__r1],A
	.dbline 105
; 		}
	xjmp L15
L16:
	.dbline 108
; 
; 		else
; 		{
	.dbline 109
; 			Cmd->Direction = FWD;
	mov REG[0xd0],>__r0
	mov A,[X-5]
	add A,3
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	.dbline 110
; 		}
	.dbline 111
; 	}
	xjmp L15
L14:
	.dbline 114
; 	
; 	else 
; 	{
	.dbline 115
; 		if (RxByte & 0x04) 
	tst [X-4],4
	jz L18
	.dbline 116
; 		{
	.dbline 117
; 			Cmd->Direction = CCW;
	mov REG[0xd0],>__r0
	mov A,[X-5]
	add A,3
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,1
	mvi [__r1],A
	.dbline 118
; 		}
	xjmp L19
L18:
	.dbline 121
; 		
; 		else 
; 		{
	.dbline 122
; 			Cmd->Direction = CW;
	mov REG[0xd0],>__r0
	mov A,[X-5]
	add A,3
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	.dbline 123
; 		}
L19:
	.dbline 124
; 	}
L15:
	.dbline 126
; 
; 	Cmd->Status = NEW;
	mov REG[0xd0],>__r0
	mov A,[X-5]
	add A,6
	mov [__r1],A
	mov A,[X-6]
	adc A,0
	mov REG[0xd5],A
	mov A,1
	mvi [__r1],A
	.dbline 128
; 
; 	return;
	.dbline -2
L4:
	add SP,-3
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l VelocityCode 0 c
	.dbsym l Cmd -6 pX
	.dbsym l RxByte -4 c
	.dbend
	.dbfunc e updatePID _updatePID fI
;          iTerm -> X+12
;          dTerm -> X+8
;          pTerm -> X+4
;          value -> X+0
;       position -> X-13
;          error -> X-9
;            pid -> X-5
_updatePID::
	.dbline -1
	push X
	mov X,SP
	add SP,16
	.dbline 138
; 
; }// End ProcessRxByte
; 
; //////////////////////////////////////////////////////////////////////////////////////
; /*
;  Routine to implement a PID control loop
; */
; 
; int updatePID(PIDstruct * pid, float error, float position)
; {
	.dbline 139
;   float pTerm = 0.0,
	mov [X+4],0
	mov [X+5],0
	mov [X+6],0
	mov [X+7],0
	.dbline 140
;   		dTerm = 0.0,
	mov [X+8],0
	mov [X+9],0
	mov [X+10],0
	mov [X+11],0
	.dbline 141
;   		iTerm = 0.0;
	mov [X+12],0
	mov [X+13],0
	mov [X+14],0
	mov [X+15],0
	.dbline 142
;   float value = 0.0;
	mov [X+0],0
	mov [X+1],0
	mov [X+2],0
	mov [X+3],0
	.dbline 144
; 
;   pTerm = pid->pGain * error;   // calculate the proportional term
	mov REG[0xd0],>__r0
	mov A,[X-4]
	add A,20
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	mov REG[0xd4],A
	mvi A,[__r1]
	mov [__r4],A
	mvi A,[__r1]
	mov [__r5],A
	mvi A,[__r1]
	mov [__r6],A
	mvi A,[__r1]
	mov [__r7],A
	mov A,[X-9]
	push A
	mov A,[X-8]
	push A
	mov A,[X-7]
	push A
	mov A,[X-6]
	push A
	mov A,[__r4]
	push A
	mov A,[__r5]
	push A
	mov A,[__r6]
	push A
	mov A,[__r7]
	push A
	xcall __fpmul
	pop A
	mov [X+7],A
	pop A
	mov [X+6],A
	pop A
	mov [X+5],A
	pop A
	mov [X+4],A
	add SP,-4
	.dbline 148
; 
; // calculate the integral state with appropriate limiting
; 
;   pid->iState = pid->iState + error;
	mov A,[X-4]
	add A,4
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	mov [__r0],A
	mov REG[0xd4],A
	mvi A,[__r1]
	mov [__r4],A
	mvi A,[__r1]
	mov [__r5],A
	mvi A,[__r1]
	mov [__r6],A
	mvi A,[__r1]
	sub [__r1],4
	mov [__r7],A
	mov A,[X-9]
	push A
	mov A,[X-8]
	push A
	mov A,[X-7]
	push A
	mov A,[X-6]
	push A
	mov A,[__r4]
	push A
	mov A,[__r5]
	push A
	mov A,[__r6]
	push A
	mov A,[__r7]
	push A
	xcall __fpadd
	pop A
	mov [__r7],A
	pop A
	mov [__r6],A
	pop A
	mov [__r5],A
	pop A
	mov [__r4],A
	add SP,-4
	mov A,[__r0]
	mov REG[0xd5],A
	mov A,[__r4]
	mvi [__r1],A
	mov A,[__r5]
	mvi [__r1],A
	mov A,[__r6]
	mvi [__r1],A
	mov A,[__r7]
	mvi [__r1],A
	.dbline 149
;   if (pid->iState > pid->iMax)
	mov A,[X-4]
	add A,8
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	mov REG[0xd4],A
	mvi A,[__r1]
	mov [__r4],A
	mvi A,[__r1]
	mov [__r5],A
	mvi A,[__r1]
	mov [__r6],A
	mvi A,[__r1]
	mov [__r7],A
	mov A,[X-4]
	add A,4
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	mov REG[0xd4],A
	mvi A,[__r1]
	mov [__r8],A
	mvi A,[__r1]
	mov [__r9],A
	mvi A,[__r1]
	mov [__r10],A
	mvi A,[__r1]
	mov [__r11],A
	mov A,[__r4]
	push A
	mov A,[__r5]
	push A
	mov A,[__r6]
	push A
	mov A,[__r7]
	push A
	mov A,[__r8]
	push A
	mov A,[__r9]
	push A
	mov A,[__r10]
	push A
	mov A,[__r11]
	push A
	xcall __fpcmp
	add SP,-8
	cmp A,0
	jz L21
	cmp A,1
	jnz L21
	.dbline 150
;   {
	.dbline 151
; 	  pid->iState = pid->iMax;
	mov A,[X-4]
	add A,8
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	mov REG[0xd4],A
	mvi A,[__r1]
	mov [__r4],A
	mvi A,[__r1]
	mov [__r5],A
	mvi A,[__r1]
	mov [__r6],A
	mvi A,[__r1]
	mov [__r7],A
	mov A,[X-4]
	add A,4
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	mov REG[0xd5],A
	mov A,[__r4]
	mvi [__r1],A
	mov A,[__r5]
	mvi [__r1],A
	mov A,[__r6]
	mvi [__r1],A
	mov A,[__r7]
	mvi [__r1],A
	.dbline 152
;   }
	xjmp L22
L21:
	.dbline 154
; 
;   else if (pid->iState < pid->iMin)
	mov REG[0xd0],>__r0
	mov A,[X-4]
	add A,12
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	mov REG[0xd4],A
	mvi A,[__r1]
	mov [__r4],A
	mvi A,[__r1]
	mov [__r5],A
	mvi A,[__r1]
	mov [__r6],A
	mvi A,[__r1]
	mov [__r7],A
	mov A,[X-4]
	add A,4
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	mov REG[0xd4],A
	mvi A,[__r1]
	mov [__r8],A
	mvi A,[__r1]
	mov [__r9],A
	mvi A,[__r1]
	mov [__r10],A
	mvi A,[__r1]
	mov [__r11],A
	mov A,[__r4]
	push A
	mov A,[__r5]
	push A
	mov A,[__r6]
	push A
	mov A,[__r7]
	push A
	mov A,[__r8]
	push A
	mov A,[__r9]
	push A
	mov A,[__r10]
	push A
	mov A,[__r11]
	push A
	xcall __fpcmp
	add SP,-8
	cmp A,0
	jz L23
	cmp A,1
	jz L23
	.dbline 155
;   {
	.dbline 156
; 	  pid->iState = pid->iMin;
	mov A,[X-4]
	add A,12
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	mov REG[0xd4],A
	mvi A,[__r1]
	mov [__r4],A
	mvi A,[__r1]
	mov [__r5],A
	mvi A,[__r1]
	mov [__r6],A
	mvi A,[__r1]
	mov [__r7],A
	mov A,[X-4]
	add A,4
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	mov REG[0xd5],A
	mov A,[__r4]
	mvi [__r1],A
	mov A,[__r5]
	mvi [__r1],A
	mov A,[__r6]
	mvi [__r1],A
	mov A,[__r7]
	mvi [__r1],A
	.dbline 157
;   }
L23:
L22:
	.dbline 159
; 
;   iTerm = pid->iGain * pid->iState;  // calculate the integral term
	mov REG[0xd0],>__r0
	mov A,[X-4]
	add A,4
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	mov REG[0xd4],A
	mvi A,[__r1]
	mov [__r4],A
	mvi A,[__r1]
	mov [__r5],A
	mvi A,[__r1]
	mov [__r6],A
	mvi A,[__r1]
	mov [__r7],A
	mov A,[X-4]
	add A,16
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	mov REG[0xd4],A
	mvi A,[__r1]
	mov [__r8],A
	mvi A,[__r1]
	mov [__r9],A
	mvi A,[__r1]
	mov [__r10],A
	mvi A,[__r1]
	mov [__r11],A
	mov A,[__r4]
	push A
	mov A,[__r5]
	push A
	mov A,[__r6]
	push A
	mov A,[__r7]
	push A
	mov A,[__r8]
	push A
	mov A,[__r9]
	push A
	mov A,[__r10]
	push A
	mov A,[__r11]
	push A
	xcall __fpmul
	pop A
	mov [X+15],A
	pop A
	mov [X+14],A
	pop A
	mov [X+13],A
	pop A
	mov [X+12],A
	add SP,-4
	.dbline 161
; 
;   dTerm = pid->dGain * (pid->dState - position);
	mov A,[X-4]
	mov [__r1],A
	mov A,[X-5]
	mov REG[0xd4],A
	mvi A,[__r1]
	mov [__r4],A
	mvi A,[__r1]
	mov [__r5],A
	mvi A,[__r1]
	mov [__r6],A
	mvi A,[__r1]
	mov [__r7],A
	mov A,[X-13]
	push A
	mov A,[X-12]
	push A
	mov A,[X-11]
	push A
	mov A,[X-10]
	push A
	mov A,[__r4]
	push A
	mov A,[__r5]
	push A
	mov A,[__r6]
	push A
	mov A,[__r7]
	push A
	xcall __fpsub
	pop A
	mov [__r3],A
	pop A
	mov [__r2],A
	pop A
	mov [__r1],A
	pop A
	mov [__r0],A
	add SP,-4
	mov A,[X-4]
	add A,24
	mov [__r5],A
	mov A,[X-5]
	adc A,0
	mov REG[0xd4],A
	mvi A,[__r5]
	mov [__r8],A
	mvi A,[__r5]
	mov [__r9],A
	mvi A,[__r5]
	mov [__r10],A
	mvi A,[__r5]
	mov [__r11],A
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	mov A,[__r2]
	push A
	mov A,[__r3]
	push A
	mov A,[__r8]
	push A
	mov A,[__r9]
	push A
	mov A,[__r10]
	push A
	mov A,[__r11]
	push A
	xcall __fpmul
	pop A
	mov [X+11],A
	pop A
	mov [X+10],A
	pop A
	mov [X+9],A
	pop A
	mov [X+8],A
	add SP,-4
	.dbline 162
;   pid->dState = position;
	mov A,[X-4]
	mov [__r1],A
	mov A,[X-5]
	mov REG[0xd5],A
	mov A,[X-13]
	mvi [__r1],A
	mov A,[X-12]
	mvi [__r1],A
	mov A,[X-11]
	mvi [__r1],A
	mov A,[X-10]
	mvi [__r1],A
	.dbline 164
; 
;   value = (pTerm + iTerm + dTerm + 0.5);
	mov A,[X+12]
	push A
	mov A,[X+13]
	push A
	mov A,[X+14]
	push A
	mov A,[X+15]
	push A
	mov A,[X+4]
	push A
	mov A,[X+5]
	push A
	mov A,[X+6]
	push A
	mov A,[X+7]
	push A
	xcall __fpadd
	pop A
	mov [__r3],A
	pop A
	mov [__r2],A
	pop A
	mov [__r1],A
	pop A
	mov [__r0],A
	add SP,-4
	mov A,[X+8]
	push A
	mov A,[X+9]
	push A
	mov A,[X+10]
	push A
	mov A,[X+11]
	push A
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	mov A,[__r2]
	push A
	mov A,[__r3]
	push A
	xcall __fpadd
	pop A
	mov [__r3],A
	pop A
	mov [__r2],A
	pop A
	mov [__r1],A
	pop A
	mov [__r0],A
	add SP,-4
	mov A,63
	push A
	mov A,0
	push A
	push A
	push A
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	mov A,[__r2]
	push A
	mov A,[__r3]
	push A
	xcall __fpadd
	pop A
	mov [X+3],A
	pop A
	mov [X+2],A
	pop A
	mov [X+1],A
	pop A
	mov [X+0],A
	add SP,-4
	.dbline 165
;   if (value > PWM_MAX)
	mov A,67
	push A
	mov A,127
	push A
	mov A,0
	push A
	push A
	mov A,[X+0]
	push A
	mov A,[X+1]
	push A
	mov A,[X+2]
	push A
	mov A,[X+3]
	push A
	xcall __fpcmp
	add SP,-8
	cmp A,0
	jz L25
	cmp A,1
	jnz L25
	.dbline 166
;   {
	.dbline 167
; 	  value = PWM_MAX;
	mov [X+0],67
	mov [X+1],127
	mov [X+2],0
	mov [X+3],0
	.dbline 168
;   }
L25:
	.dbline 170
; 
;   if (value < PWM_MIN)
	mov A,0
	push A
	push A
	push A
	push A
	mov A,[X+0]
	push A
	mov A,[X+1]
	push A
	mov A,[X+2]
	push A
	mov A,[X+3]
	push A
	mov REG[0xd0],>__r0
	xcall __fpcmp
	add SP,-8
	cmp A,0
	jz L27
	cmp A,1
	jz L27
	.dbline 171
;   {
	.dbline 172
; 	  value = PWM_MIN;
	mov [X+0],0
	mov [X+1],0
	mov [X+2],0
	mov [X+3],0
	.dbline 173
;   }
L27:
	.dbline 175
; 
;   return ((int) value);
	mov REG[0xd0],>__r0
	mov A,[X+0]
	push A
	mov A,[X+1]
	push A
	mov A,[X+2]
	push A
	mov A,[X+3]
	push A
	xcall __fp2long
	pop A
	mov [__r1],A
	pop A
	mov [__r0],A
	add SP,-2
	.dbline -2
L20:
	add SP,-16
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l iTerm 12 D
	.dbsym l dTerm 8 D
	.dbsym l pTerm 4 D
	.dbsym l value 0 D
	.dbsym l position -13 D
	.dbsym l error -9 D
	.dbsym l pid -5 pX
	.dbend
	.dbfunc e ControlWheel _ControlWheel fV
;          Start -> X+7
;          error -> X+5
;   wReadCounter -> X+3
;        LS_MASK -> X+2
;     deltaCount -> X+0
;            PID -> X-9
;          Wheel -> X-7
;            Cmd -> X-5
_ControlWheel::
	.dbline -1
	push X
	mov X,SP
	add SP,8
	.dbline 180
; }
; /////////////////////////////////////////////////////////////////////////////
; 
; void ControlWheel(CmdStruct * Cmd, WheelStruct * Wheel, PIDstruct * PID)
; {
	.dbline 181
; 	WORD	wReadCounter = 0;
	mov [X+4],0
	mov [X+3],0
	.dbline 182
; 	int		error = 0;
	mov [X+6],0
	mov [X+5],0
	.dbline 183
; 	int		deltaCount = 0;
	mov [X+1],0
	mov [X+0],0
	.dbline 184
; 	BYTE	LS_MASK = 0;
	mov [X+2],0
	.dbline 187
; 	BOOL	Start;
; 
; 	if (Cmd->Status == NEW)
	mov REG[0xd0],>__r0
	mov A,[X-4]
	add A,6
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	mov REG[0xd4],A
	mvi A,[__r1]
	cmp A,1
	jnz L30
	.dbline 188
; 	{
	.dbline 189
; 		Counter16_1_Stop();
	push X
	xcall _Counter16_1_Stop
	.dbline 190
; 		Counter16_1_WritePeriod(PRESET_CNT);
	mov A,-1
	mov X,A
	xcall _Counter16_1_WritePeriod
	.dbline 191
; 		Counter16_1_Start();
	xcall _Counter16_1_Start
	pop X
	.dbline 196
; //		Counter16_2_Stop();
; //		Counter16_2_WritePeriod(PRESET_CNT);
; //		Counter16_2_Start();
; 
; 		if (Cmd->MotionType == TRANS)
	mov REG[0xd0],>__r0
	mov A,[X-4]
	mov [__r1],A
	mov A,[X-5]
	mov REG[0xd4],A
	mvi A,[__r1]
	cmp A,0
	jnz L32
	.dbline 197
; 		{
	.dbline 198
; 			if (Wheel->id == WEST)
	mov A,[X-6]
	mov [__r1],A
	mov A,[X-7]
	mov REG[0xd4],A
	mvi A,[__r1]
	mov [__r0],A
	mvi A,[__r1]
	cmp [__r0],0
	jnz L34
	cmp A,0
	jnz L34
X9:
	.dbline 199
; 			{
	.dbline 200
; 				Wheel->direction = Cmd->Direction;
	mov REG[0xd0],>__r0
	mov A,[X-4]
	add A,3
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	mov REG[0xd4],A
	mvi A,[__r1]
	mov [__r1],A
	mov A,[X-6]
	add A,2
	mov [__r3],A
	mov A,[X-7]
	adc A,0
	mov REG[0xd5],A
	mov A,0
	mvi [__r3],A
	mov A,[__r1]
	mvi [__r3],A
	.dbline 201
; 				Wheel->Velocity = Cmd->Velocity;
	mov A,[X-4]
	add A,1
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	mov REG[0xd4],A
	mvi A,[__r1]
	mov [__r0],A
	mvi A,[__r1]
	mov [__r1],A
	mov A,[X-6]
	add A,4
	mov [__r3],A
	mov A,[X-7]
	adc A,0
	mov REG[0xd5],A
	mov A,[__r0]
	mvi [__r3],A
	mov A,[__r1]
	mvi [__r3],A
	.dbline 202
; 			}
	xjmp L35
L34:
	.dbline 205
; 
; 			else
; 			{
	.dbline 206
; 				Wheel->direction = Cmd->Direction;
	mov REG[0xd0],>__r0
	mov A,[X-4]
	add A,3
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	mov REG[0xd4],A
	mvi A,[__r1]
	mov [__r1],A
	mov A,[X-6]
	add A,2
	mov [__r3],A
	mov A,[X-7]
	adc A,0
	mov REG[0xd5],A
	mov A,0
	mvi [__r3],A
	mov A,[__r1]
	mvi [__r3],A
	.dbline 207
; 				Wheel->Velocity = Cmd->Velocity;
	mov A,[X-4]
	add A,1
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	mov REG[0xd4],A
	mvi A,[__r1]
	mov [__r0],A
	mvi A,[__r1]
	mov [__r1],A
	mov A,[X-6]
	add A,4
	mov [__r3],A
	mov A,[X-7]
	adc A,0
	mov REG[0xd5],A
	mov A,[__r0]
	mvi [__r3],A
	mov A,[__r1]
	mvi [__r3],A
	.dbline 208
; 			}
L35:
	.dbline 209
; 		}
L32:
	.dbline 211
; 		
; 		if (Cmd->MotionType == ROT)
	mov REG[0xd0],>__r0
	mov A,[X-4]
	mov [__r1],A
	mov A,[X-5]
	mov REG[0xd4],A
	mvi A,[__r1]
	cmp A,1
	jnz L36
	.dbline 212
; 		{
	.dbline 213
; 			if(Cmd->Direction == CW)
	mov A,[X-4]
	add A,3
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	mov REG[0xd4],A
	mvi A,[__r1]
	cmp A,0
	jnz L38
	.dbline 214
; 			{
	.dbline 215
; 				if(Wheel->id == WEST)
	mov A,[X-6]
	mov [__r1],A
	mov A,[X-7]
	mov REG[0xd4],A
	mvi A,[__r1]
	mov [__r0],A
	mvi A,[__r1]
	cmp [__r0],0
	jnz L40
	cmp A,0
	jnz L40
X10:
	.dbline 216
; 				{
	.dbline 217
; 					Wheel->direction = FWD;
	mov REG[0xd0],>__r0
	mov A,[X-6]
	add A,2
	mov [__r1],A
	mov A,[X-7]
	adc A,0
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	mvi [__r1],A
	.dbline 218
; 					Wheel->Velocity = Cmd->Velocity;
	mov A,[X-4]
	add A,1
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	mov REG[0xd4],A
	mvi A,[__r1]
	mov [__r0],A
	mvi A,[__r1]
	mov [__r1],A
	mov A,[X-6]
	add A,4
	mov [__r3],A
	mov A,[X-7]
	adc A,0
	mov REG[0xd5],A
	mov A,[__r0]
	mvi [__r3],A
	mov A,[__r1]
	mvi [__r3],A
	.dbline 219
; 				}
	xjmp L39
L40:
	.dbline 222
; 				
; 				else
; 				{
	.dbline 223
; 					Wheel->direction = BWD;
	mov REG[0xd0],>__r0
	mov A,[X-6]
	add A,2
	mov [__r1],A
	mov A,[X-7]
	adc A,0
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	mov A,1
	mvi [__r1],A
	.dbline 224
; 					Wheel->Velocity = Cmd->Velocity;
	mov A,[X-4]
	add A,1
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	mov REG[0xd4],A
	mvi A,[__r1]
	mov [__r0],A
	mvi A,[__r1]
	mov [__r1],A
	mov A,[X-6]
	add A,4
	mov [__r3],A
	mov A,[X-7]
	adc A,0
	mov REG[0xd5],A
	mov A,[__r0]
	mvi [__r3],A
	mov A,[__r1]
	mvi [__r3],A
	.dbline 225
; 				}
	.dbline 226
; 			}// end CW
	xjmp L39
L38:
	.dbline 229
; 			
; 			else	// CCW
; 			{	
	.dbline 230
; 				if(Wheel->id == WEST)
	mov REG[0xd0],>__r0
	mov A,[X-6]
	mov [__r1],A
	mov A,[X-7]
	mov REG[0xd4],A
	mvi A,[__r1]
	mov [__r0],A
	mvi A,[__r1]
	cmp [__r0],0
	jnz L42
	cmp A,0
	jnz L42
X11:
	.dbline 231
; 				{
	.dbline 232
; 					Wheel->direction = BWD;
	mov REG[0xd0],>__r0
	mov A,[X-6]
	add A,2
	mov [__r1],A
	mov A,[X-7]
	adc A,0
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	mov A,1
	mvi [__r1],A
	.dbline 233
; 					Wheel->Velocity = Cmd->Velocity;
	mov A,[X-4]
	add A,1
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	mov REG[0xd4],A
	mvi A,[__r1]
	mov [__r0],A
	mvi A,[__r1]
	mov [__r1],A
	mov A,[X-6]
	add A,4
	mov [__r3],A
	mov A,[X-7]
	adc A,0
	mov REG[0xd5],A
	mov A,[__r0]
	mvi [__r3],A
	mov A,[__r1]
	mvi [__r3],A
	.dbline 234
; 				}
	xjmp L43
L42:
	.dbline 237
; 				
; 				else
; 				{
	.dbline 238
; 					Wheel->direction = FWD;
	mov REG[0xd0],>__r0
	mov A,[X-6]
	add A,2
	mov [__r1],A
	mov A,[X-7]
	adc A,0
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	mvi [__r1],A
	.dbline 239
; 					Wheel->Velocity = Cmd->Velocity;
	mov A,[X-4]
	add A,1
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	mov REG[0xd4],A
	mvi A,[__r1]
	mov [__r0],A
	mvi A,[__r1]
	mov [__r1],A
	mov A,[X-6]
	add A,4
	mov [__r3],A
	mov A,[X-7]
	adc A,0
	mov REG[0xd5],A
	mov A,[__r0]
	mvi [__r3],A
	mov A,[__r1]
	mvi [__r3],A
	.dbline 240
; 				}
L43:
	.dbline 241
; 			}	// end CCW
L39:
	.dbline 242
; 		}	// end ROT
L36:
	.dbline 244
; 
; 		if (Wheel->id == EAST)
	mov REG[0xd0],>__r0
	mov A,[X-6]
	mov [__r1],A
	mov A,[X-7]
	mov REG[0xd4],A
	mvi A,[__r1]
	mov [__r0],A
	mvi A,[__r1]
	cmp [__r0],0
	jnz L29
	cmp A,1
	jnz L29
X12:
	.dbline 245
; 		{
	.dbline 246
; 			Cmd->Status = OLD;
	mov REG[0xd0],>__r0
	mov A,[X-4]
	add A,6
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	.dbline 247
; 		}
	.dbline 248
;     }
	xjmp L29
L30:
	.dbline 251
; 
;     else
;     {
	.dbline 252
; 		LS_MASK = (PRT2DR | IS_LN_MSK);
	mov A,REG[0x8]
	mov REG[0xd0],>__r0
	mov [__r0],A
	or [__r0],1
	mov A,[__r0]
	mov [X+2],A
	.dbline 254
; 			
; 		if (Cmd->LineFollow)
	mov A,[X-4]
	add A,7
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	mov REG[0xd4],A
	mvi A,[__r1]
	cmp A,0
	jz L46
	.dbline 255
; 		{
	.dbline 256
; 			if (Cmd->END_SENSOR && !Cmd->MotionType)
	mov A,[X-4]
	add A,11
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	mov REG[0xd4],A
	mvi A,[__r1]
	cmp A,0
	jz L48
	mov A,[X-4]
	mov [__r1],A
	mov A,[X-5]
	mov REG[0xd4],A
	mvi A,[__r1]
	cmp A,0
	jnz L48
	.dbline 257
; 	    	{
	.dbline 258
; 	    		Wheel->Velocity = 0;
	mov A,[X-6]
	add A,4
	mov [__r1],A
	mov A,[X-7]
	adc A,0
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	mvi [__r1],A
	.dbline 259
; 	    		Cmd->Velocity = 0;
	mov A,[X-4]
	add A,1
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	mov REG[0xd5],A
	mov A,0
	mvi [__r1],A
	mvi [__r1],A
	.dbline 260
; 	   		}
L48:
	.dbline 261
; 	 	}
L46:
	.dbline 263
; 		
; 		if (Wheel->id == WEST)
	mov REG[0xd0],>__r0
	mov A,[X-6]
	mov [__r1],A
	mov A,[X-7]
	mov REG[0xd4],A
	mvi A,[__r1]
	mov [__r0],A
	mvi A,[__r1]
	cmp [__r0],0
	jnz L50
	cmp A,0
	jnz L50
X13:
	.dbline 264
; 		{
	.dbline 265
; 			Cmd->wReadCounter = Counter16_1_wReadCounter();
	push X
	xcall _Counter16_1_wReadCounter
	mov REG[0xd0],>__r0
	mov [__r1],A
	mov [__r0],X
	pop X
	mov A,[X-4]
	add A,38
	mov [__r3],A
	mov A,[X-5]
	adc A,0
	mov REG[0xd5],A
	mov A,[__r0]
	mvi [__r3],A
	mov A,[__r1]
	mvi [__r3],A
	.dbline 266
; 			deltaCount = (Wheel->position - Cmd->wReadCounter);
	mov A,[X-4]
	add A,38
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	mov REG[0xd4],A
	mvi A,[__r1]
	mov [__r0],A
	mvi A,[__r1]
	mov [__r1],A
	mov A,[X-6]
	add A,6
	mov [__r3],A
	mov A,[X-7]
	adc A,0
	mov REG[0xd4],A
	mvi A,[__r3]
	mov [__r2],A
	mvi A,[__r3]
	sub A,[__r1]
	mov [__r1],A
	mov A,[__r2]
	sbb A,[__r0]
	mov [__r0],A
	mov A,[__r1]
	mov [X+1],A
	mov A,[__r0]
	mov [X+0],A
	.dbline 267
; 			Cmd->error = Wheel->Velocity - deltaCount;
	mov A,[X-6]
	add A,4
	mov [__r1],A
	mov A,[X-7]
	adc A,0
	mov REG[0xd4],A
	mvi A,[__r1]
	mov [__r0],A
	mvi A,[__r1]
	mov [__r1],A
	mov A,[X+1]
	sub [__r1],A
	mov A,[X+0]
	sbb [__r0],A
	mov A,[X-4]
	add A,36
	mov [__r3],A
	mov A,[X-5]
	adc A,0
	mov REG[0xd5],A
	mov A,[__r0]
	mvi [__r3],A
	mov A,[__r1]
	mvi [__r3],A
	.dbline 268
; 			Cmd->PWMvalue = updatePID(PID, Cmd->error, Wheel->position);
	mov A,[X-6]
	add A,6
	mov [__r1],A
	mov A,[X-7]
	adc A,0
	mov REG[0xd4],A
	mvi A,[__r1]
	mov [__r0],A
	mvi A,[__r1]
	mov [__r1],A
	and A,1
	mov [__r3],A
	mov A,[__r0]
	and A,0
	mov [__r2],A
	mov A,[__r3]
	mov [__r7],A
	mov A,[__r2]
	mov [__r6],A
	tst [__r6],-128
	jz X14
	mov [__r5],-1
	mov [__r4],-1
	jmp X15
X14:
	mov REG[0xd0],>__r0
	mov [__r5],0
	mov [__r4],0
X15:
	mov REG[0xd0],>__r0
	mov A,[__r4]
	push A
	mov A,[__r5]
	push A
	mov A,[__r6]
	push A
	mov A,[__r7]
	push A
	xcall __long2fp
	pop A
	mov [__r7],A
	pop A
	mov [__r6],A
	pop A
	mov [__r5],A
	pop A
	mov [__r4],A
	and F,-5
	rrc [__r0]
	rrc [__r1]
	mov A,[__r1]
	mov [__r3],A
	mov A,[__r0]
	mov [__r2],A
	tst [__r2],-128
	jz X16
	mov [__r1],-1
	mov [__r0],-1
	jmp X17
X16:
	mov REG[0xd0],>__r0
	mov [__r1],0
	mov [__r0],0
X17:
	mov REG[0xd0],>__r0
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	mov A,[__r2]
	push A
	mov A,[__r3]
	push A
	xcall __long2fp
	pop A
	mov [__r3],A
	pop A
	mov [__r2],A
	pop A
	mov [__r1],A
	pop A
	push A
	mov A,[__r1]
	push A
	mov A,[__r2]
	push A
	mov A,[__r3]
	push A
	mov A,64
	push A
	mov A,0
	push A
	push A
	push A
	xcall __fpmul
	pop A
	mov [__r3],A
	pop A
	mov [__r2],A
	pop A
	mov [__r1],A
	pop A
	mov [__r0],A
	add SP,-4
	mov A,[__r4]
	push A
	mov A,[__r5]
	push A
	mov A,[__r6]
	push A
	mov A,[__r7]
	push A
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	mov A,[__r2]
	push A
	mov A,[__r3]
	push A
	xcall __fpadd
	pop A
	mov [__r3],A
	pop A
	mov [__r2],A
	pop A
	mov [__r1],A
	pop A
	add SP,-4
	push A
	mov A,[__r1]
	push A
	mov A,[__r2]
	push A
	mov A,[__r3]
	push A
	mov A,[X-4]
	add A,36
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	mov REG[0xd4],A
	mvi A,[__r1]
	mov [__r0],A
	mvi A,[__r1]
	mov [__r3],A
	mov A,[__r0]
	mov [__r2],A
	tst [__r2],-128
	jz X18
	mov [__r1],-1
	mov [__r0],-1
	jmp X19
X18:
	mov REG[0xd0],>__r0
	mov [__r1],0
	mov [__r0],0
X19:
	mov REG[0xd0],>__r0
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	mov A,[__r2]
	push A
	mov A,[__r3]
	push A
	xcall __long2fp
	pop A
	mov [__r3],A
	pop A
	mov [__r2],A
	pop A
	mov [__r1],A
	pop A
	push A
	mov A,[__r1]
	push A
	mov A,[__r2]
	push A
	mov A,[__r3]
	push A
	mov A,[X-9]
	push A
	mov A,[X-8]
	push A
	xcall _updatePID
	add SP,-10
	mov REG[0xd0],>__r0
	mov A,[X-4]
	add A,41
	mov [__r3],A
	mov A,[X-5]
	adc A,0
	mov REG[0xd5],A
	mov A,[__r0]
	mvi [__r3],A
	mov A,[__r1]
	mvi [__r3],A
	.dbline 269
; 			Wheel->position = Cmd->wReadCounter;
	mov A,[X-4]
	add A,38
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	mov REG[0xd4],A
	mvi A,[__r1]
	mov [__r0],A
	mvi A,[__r1]
	mov [__r1],A
	mov A,[X-6]
	add A,6
	mov [__r3],A
	mov A,[X-7]
	adc A,0
	mov REG[0xd5],A
	mov A,[__r0]
	mvi [__r3],A
	mov A,[__r1]
	mvi [__r3],A
	.dbline 270
; 		}
L50:
	.dbline 272
; 
; 		Motor(Wheel->id, Cmd->PWMvalue, Wheel->direction);
	mov REG[0xd0],>__r0
	mov A,[X-6]
	add A,2
	mov [__r1],A
	mov A,[X-7]
	adc A,0
	mov REG[0xd4],A
	mvi A,[__r1]
	mvi A,[__r1]
	push A
	mov A,[X-4]
	add A,41
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	mov REG[0xd4],A
	mvi A,[__r1]
	mov [__r0],A
	mvi A,[__r1]
	mov [__r1],A
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	mov A,[X-6]
	mov [__r1],A
	mov A,[X-7]
	mov REG[0xd4],A
	mvi A,[__r1]
	mov [__r0],A
	mvi A,[__r1]
	mov [__r1],A
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	xcall _Motor
	add SP,-5
	.dbline 273
; 	}
	.dbline 275
; 
; 	return;
	.dbline -2
L29:
	add SP,-8
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l Start 7 c
	.dbsym l error 5 I
	.dbsym l wReadCounter 3 i
	.dbsym l LS_MASK 2 c
	.dbsym l deltaCount 0 I
	.dbsym l PID -9 pX
	.dbsym l Wheel -7 pX
	.dbsym l Cmd -5 pX
	.dbend
