	cpu LMM
	.module main.c
	.area data(ram, con, rel)
_TimeSlot::
	.word 0
	.dbfile ./main.c
	.dbsym e TimeSlot _TimeSlot I
	.area data(ram, con, rel)
	.dbfile ./main.c
	.area data(ram, con, rel)
	.dbfile ./main.c
_SliceCounter::
	.word 0
	.dbsym e SliceCounter _SliceCounter I
	.area data(ram, con, rel)
	.dbfile ./main.c
	.area lit(rom, con, rel)
L5:
	.byte 32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32
	.byte 0
	.area text(rom, con, rel)
	.dbfile ./main.c
	.dbfunc e main _main fV
;            str -> X+155
;          blank -> X+138
;          Weigh -> X+137
;        EastPID -> X+109
;        WestPID -> X+81
;      bTxStatus -> X+80
;      WestWheel -> X+72
;      EastWheel -> X+64
;      bRxStatus -> X+63
;        loopcnt -> X+61
;      StsTxByte -> X+60
;      R_LS_Mask -> X+59
;           Stop -> X+58
;      CmdRxByte -> X+57
;    PSoC_Select -> X+56
;            pwr -> X+48
;        Command -> X+5
;      L_LS_Mask -> X+4
;            cnt -> X+2
;        LS_Mask -> X+1
;           Mask -> X+0
_main::
	.dbline -1
	push X
	mov X,SP
	add SP,-82
	.dbline 19
; //----------------------------------------------------------------------------
; // C main line
; //----------------------------------------------------------------------------
; #include <m8c.h>        // part specific constants and macros
; #include "PSoCAPI.h"    // PSoC API definitions for all User Modules
; #include <stdlib.h>
; #include "motorcontroller.h"
; #include "rx8_1.h"
; #include <psocgpioint.h>
; 
; // Global Variables
; 
; int 	TimeSlot = 0;			// Scheduler variable
; int 	SliceCounter = 0;		// Scheduler variable
; 
; // Main Program
; 
; void main()
; {
	.dbline 31
; 
; // Variables
; 
; 	PIDstruct	WestPID;
; 	PIDstruct	EastPID;
; 	CmdStruct	Command;
; 	WheelStruct	EastWheel;
; 	WheelStruct WestWheel;
; 
; 	BYTE		bRxStatus;
; 	BYTE		bTxStatus;
; 	BYTE		CmdRxByte = 0;			// Rx interrupt Variables
	mov [X+57],0
	.dbline 32
; 	BYTE		StsTxByte = 0;			// Tx interrupt Variables
	mov [X+60],0
	.dbline 33
; 	BYTE		LS_Mask = 0;
	mov [X+1],0
	.dbline 34
; 	BYTE		R_LS_Mask = 0;
	mov [X+59],0
	.dbline 35
; 	BYTE		L_LS_Mask = 0;
	mov [X+4],0
	.dbline 36
; 	BYTE		Mask = 0;
	mov [X+0],0
	.dbline 42
; 	BOOL		Stop;
; 	BOOL		PSoC_Select;
; 	BOOL		Weigh;
; 
; 	char 	    str[17];			            // One line of characters for LCD
; 	char		blank[] = "                ";	// Clear a line of LCD
	mov REG[0xd0],>__r0
	mov [__r1],<L5
	mov [__r0],>L5
	mov [__r3],X
	add [__r3],-118
	mov REG[0xd5],7
	push X
	mov [__rX],0
	mov A,[__r0]
	mov X,[__r1]
X4:
	push A
	romx
	mov REG[0xd0],>__r0
	mvi [__r3],A
	pop A
	inc X
	adc A,0
	inc [__rX]
	cmp [__rX],17
	jnz X4
	pop X
	.dbline 46
; 
; 	int 		pwr[4];
; 	int			cnt;
; 	int			loopcnt = 0;
	mov [X+62],0
	mov [X+61],0
	.dbline 50
; 
; // Initialization
; 
; 	initPSoC(); 						// Init PSoC functions
	xcall _initPSoC
	.dbline 51
; 	StopMotor(BOTH);
	mov A,0
	push A
	mov A,2
	push A
	xcall _StopMotor
	add SP,-2
	.dbline 52
; 	PIDinit(&WestPID);					// Initialize the PID control loops
	mov REG[0xd0],>__r0
	mov [__r1],X
	add [__r1],81
	mov A,7
	push A
	mov A,[__r1]
	push A
	xcall _PIDinit
	.dbline 53
; 	PIDinit(&EastPID);
	mov REG[0xd0],>__r0
	mov [__r1],X
	add [__r1],109
	mov A,7
	push A
	mov A,[__r1]
	push A
	xcall _PIDinit
	add SP,-4
	.dbline 54
; 	StsTxByte |= PSOCSTOP;
	mov REG[0xd0],>__r0
	mov A,[X+60]
	or A,8
	mov [X+60],A
	.dbline 56
; 
; 	EastWheel.id = EAST;				// Initialize Wheel Structs
	mov [X+65],1
	mov [X+64],0
	.dbline 57
; 	WestWheel.id = WEST;
	mov [X+73],0
	mov [X+72],0
	.dbline 58
; 	Command.Status = NEW;				// Initialize Command Structs
	mov [X+11],1
	.dbline 59
; 	Command.Velocity = 0;
	mov [X+7],0
	mov [X+6],0
	.dbline 60
; 	Command.error = 0;
	mov [X+42],0
	mov [X+41],0
	.dbline 61
; 	Command.wReadCounter = 0;
	mov [X+44],0
	mov [X+43],0
	.dbline 62
; 	Command.END_SENSOR = FALSE;
	mov [X+16],0
	.dbline 63
; 	Command.PWMvalue = 0;
	mov [X+47],0
	mov [X+46],0
	.dbline 65
; 
; 	Stop = FALSE;
	mov [X+58],0
	.dbline 66
; 	PSoC_Select = FALSE;
	mov [X+56],0
	.dbline 67
; 	Weigh = FALSE;
	mov [X-119],0
	.dbline 69
; 
; 	pwr[0] = 1;
	mov [X+49],1
	mov [X+48],0
	.dbline 70
; 	pwr[1] = 2;
	mov [X+51],2
	mov [X+50],0
	.dbline 71
; 	pwr[2] = 4;
	mov [X+53],4
	mov [X+52],0
	.dbline 72
; 	pwr[3] = 8;
	mov [X+55],8
	mov [X+54],0
	xjmp L16
L15:
	.dbline 75
; 
; 	while(TRUE)
; 	{
	.dbline 80
; // Do this every 10 ms
; // Check to see if we got a byte from XBC.  If so check to see
; // if data or command byte.  Then go ahead and process the byte.
; 
; 		if (TimeSlot & 2)
	mov REG[0xd0],>_TimeSlot
	mov A,[_TimeSlot+1]
	and A,2
	mov REG[0xd0],>__r0
	mov [__r1],A
	mov REG[0xd0],>_TimeSlot
	mov A,[_TimeSlot]
	and A,0
	mov REG[0xd0],>__r0
	cmp A,0
	jnz X5
	cmp [__r1],0
	jz L18
X5:
	.dbline 81
; 		{
	.dbline 82
; 			TimeSlot ^= 2;
	mov REG[0xd0],>_TimeSlot
	xor [_TimeSlot+1],2
	xor [_TimeSlot],0
	.dbline 84
; 			
; 			loopcnt++;
	inc [X+62]
	adc [X+61],0
	.dbline 86
; 
; 			if (bRxStatus = RX8_1_bReadRxStatus() & RX8_RX_COMPLETE)
	push X
	xcall _RX8_1_bReadRxStatus
	mov REG[0xd0],>__r0
	pop X
	mov [__r0],A
	and [__r0],8
	mov A,[__r0]
	mov [X+63],A
	cmp [__r0],0
	jz L20
	.dbline 87
; 			{
	.dbline 88
; 				CmdRxByte = RX8_1_bReadRxData();
	push X
	xcall _RX8_1_bReadRxData
	mov REG[0xd0],>__r0
	pop X
	mov [X+57],A
	.dbline 90
; 
; 				if (CmdRxByte & EW_PSOC)
	tst [X+57],1
	jz L22
	.dbline 91
; 				{
	.dbline 92
; 					PSoC_Select = TRUE;
	mov [X+56],1
	.dbline 93
; 					TX8_1_Start(TX8_PARITY_NONE);
	push X
	mov A,0
	xcall _TX8_1_Start
	pop X
	.dbline 94
; 					ProcessRxByte(CmdRxByte, &Command);
	mov REG[0xd0],>__r0
	mov [__r1],X
	add [__r1],5
	mov A,7
	push A
	mov A,[__r1]
	push A
	mov A,[X+57]
	push A
	xcall _ProcessRxByte
	add SP,-3
	.dbline 95
; 					StsTxByte |= EW_PSOC;
	mov REG[0xd0],>__r0
	mov A,[X+60]
	or A,1
	mov [X+60],A
	.dbline 96
; 					StsTxByte &= PSOCSTART;
	and [X+60],-9
	.dbline 97
; 					StsTxByte |= STSWORD;
	mov A,[X+60]
	or A,-128
	mov [X+60],A
	.dbline 99
; 
; 					if (Command.Velocity == 0)
	cmp [X+6],0
	jnz L24
	cmp [X+7],0
	jnz L24
X6:
	.dbline 100
; 					{
	.dbline 101
; 						Weigh = TRUE;
	mov [X-119],1
	.dbline 102
; 						Stop = TRUE;
	mov [X+58],1
	.dbline 103
; 					}
L24:
	.dbline 105
; 
; 					EastWheel.position = PRESET_CNT;
	mov [X+71],-1
	mov [X+70],-1
	.dbline 106
; 					WestWheel.position = PRESET_CNT;
	mov [X+79],-1
	mov [X+78],-1
	.dbline 107
; 				}
L22:
	.dbline 109
; 
; 				bRxStatus = 0;
	mov [X+63],0
	.dbline 110
; 				RX8_1_CmdReset();
	push X
	xcall _RX8_1_CmdReset
	pop X
	.dbline 111
; 			}
L20:
	.dbline 113
; 
; 			if ((PSoC_Select) && (CmdRxByte & ALIGN) && (Command.Velocity > 0) && !(CmdRxByte & MTYPE))
	cmp [X+56],0
	jz L29
	tst [X+57],2
	jz L29
	mov A,0
	sub A,[X+7]
	mov A,[X+6]
	xor A,-128
	mov REG[0xd0],>__r0
	mov [__rX],A
	mov A,(0 ^ 0x80)
	sbb A,[__rX]
	jnc L29
X7:
	tst [X+57],32
	jnz L29
	.dbline 114
; 			{
	.dbline 115
; 				LS_Mask = (PRT2DR | IS_LN_MSK);
	mov A,REG[0x8]
	mov REG[0xd0],>__r0
	mov [__r0],A
	or [__r0],1
	mov A,[__r0]
	mov [X+1],A
	.dbline 117
; 
; 				switch (LS_Mask)
	mov A,[X+1]
	mov [X-83],A
	mov [X-84],0
	mov A,[X-83]
	sub A,-121
	mov [__rY],A
	mov A,[X-84]
	xor A,-128
	sbb A,(0 ^ 0x80)
	or A,[__rY]
	jz L36
	jnc L41
X8:
L40:
	mov A,[X-83]
	sub A,1
	mov REG[0xd0],>__r0
	mov [__rY],A
	mov A,[X-84]
	xor A,-128
	sbb A,(0 ^ 0x80)
	jc L32
	or A,[__rY]
	jz L39
X9:
L42:
	cmp [X-84],0
	jnz X10
	cmp [X-83],15
	jz L35
X10:
	xjmp L32
L41:
	mov A,[X-83]
	sub A,-61
	mov REG[0xd0],>__r0
	mov [__rY],A
	mov A,[X-84]
	xor A,-128
	sbb A,(0 ^ 0x80)
	jc L32
	or A,[__rY]
	jz L37
X11:
L43:
	cmp [X-84],0
	jnz X12
	cmp [X-83],-31
	jz L38
X12:
	xjmp L32
X0:
	.dbline 118
; 				{
L35:
	.dbline 120
; 					case LS_MSK6:
; 						Stop = TRUE;
	mov [X+58],1
	.dbline 121
; 					break;
	xjmp L30
L36:
	.dbline 124
; 
; 					case LS_MSK7:
; 						Stop = TRUE;
	mov [X+58],1
	.dbline 125
; 					break;
	xjmp L30
L37:
	.dbline 128
; 
; 					case LS_MSK8:
; 						Stop = TRUE;
	mov [X+58],1
	.dbline 129
; 					break;
	xjmp L30
L38:
	.dbline 132
; 
; 					case LS_MSK9:
; 						Stop = TRUE;
	mov [X+58],1
	.dbline 133
; 					break;
	xjmp L30
L39:
	.dbline 136
; 
; 					case IS_LN_MSK:
; 						Stop = TRUE;
	mov [X+58],1
	.dbline 137
; 					break;
	xjmp L30
L32:
	.dbline 140
; 
; 					default:
; 						Stop = FALSE;
	mov [X+58],0
	.dbline 141
; 				}
	.dbline 142
; 			}
	xjmp L30
L29:
	.dbline 144
; 
; 			else if ((PSoC_Select) && (CmdRxByte & IS_DT) && (Command.Velocity > 0) && !(CmdRxByte & MTYPE))
	cmp [X+56],0
	jz L44
	tst [X+57],-128
	jz L44
	mov A,0
	sub A,[X+7]
	mov A,[X+6]
	xor A,-128
	mov REG[0xd0],>__r0
	mov [__rX],A
	mov A,(0 ^ 0x80)
	sbb A,[__rX]
	jnc L44
X13:
	tst [X+57],32
	jnz L44
	.dbline 145
; 			{
	.dbline 146
; 				LS_Mask = (PRT2DR | IS_LN_MSK);
	mov A,REG[0x8]
	mov REG[0xd0],>__r0
	mov [__r0],A
	or [__r0],1
	mov A,[__r0]
	mov [X+1],A
	.dbline 148
; 
; 				switch (LS_Mask)
	mov A,[X+1]
	mov [X-83],A
	mov [X-84],0
	mov A,[X-83]
	sub A,-73
	mov [__rY],A
	mov A,[X-84]
	xor A,-128
	sbb A,(0 ^ 0x80)
	or A,[__rY]
	jz L65
	jnc L72
X14:
L71:
	mov A,[X-83]
	sub A,95
	mov REG[0xd0],>__r0
	mov [__rY],A
	mov A,[X-84]
	xor A,-128
	sbb A,(0 ^ 0x80)
	or A,[__rY]
	jz L59
	jnc L74
X15:
L73:
	mov A,[X-83]
	sub A,15
	mov REG[0xd0],>__r0
	mov [__rY],A
	mov A,[X-84]
	xor A,-128
	sbb A,(0 ^ 0x80)
	or A,[__rY]
	jz L55
	jnc L76
X16:
L75:
	cmp [X-84],0
	jnz X17
	cmp [X-83],1
	jz L68
X17:
	xjmp L47
L76:
	cmp [X-84],0
	jnz X18
	cmp [X-83],31
	jz L50
X18:
	xjmp L47
L74:
	mov A,[X-83]
	sub A,-121
	mov REG[0xd0],>__r0
	mov [__rY],A
	mov A,[X-84]
	xor A,-128
	sbb A,(0 ^ 0x80)
	or A,[__rY]
	jz L56
	jnc L78
X19:
L77:
	cmp [X-84],0
	jnz X20
	cmp [X-83],111
	jz L64
X20:
	xjmp L47
L78:
	mov A,[X-83]
	sub A,-113
	mov REG[0xd0],>__r0
	mov [__rY],A
	mov A,[X-84]
	xor A,-128
	sbb A,(0 ^ 0x80)
	jc L47
	or A,[__rY]
	jz L51
X21:
L79:
	cmp [X-84],0
	jnz X22
	cmp [X-83],-81
	jz L60
X22:
	xjmp L47
L72:
	mov A,[X-83]
	sub A,-37
	mov REG[0xd0],>__r0
	mov [__rY],A
	mov A,[X-84]
	xor A,-128
	sbb A,(0 ^ 0x80)
	or A,[__rY]
	jz L66
	jnc L81
X23:
L80:
	mov A,[X-83]
	sub A,-57
	mov REG[0xd0],>__r0
	mov [__rY],A
	mov A,[X-84]
	xor A,-128
	sbb A,(0 ^ 0x80)
	or A,[__rY]
	jz L52
	jnc L83
X24:
L82:
	cmp [X-84],0
	jnz X25
	cmp [X-83],-61
	jz L57
X25:
	xjmp L47
L83:
	cmp [X-84],0
	jnz X26
	cmp [X-83],-41
	jz L61
X26:
	xjmp L47
L81:
	cmp [X-84],0
	jnz X27
	cmp [X-83],-21
	jz L62
X27:
	mov A,[X-83]
	sub A,-19
	mov REG[0xd0],>__r0
	mov [__rY],A
	mov A,[X-84]
	xor A,-128
	sbb A,(0 ^ 0x80)
	or A,[__rY]
	jz L67
	jnc L85
X28:
L84:
	cmp [X-84],0
	jnz X29
	cmp [X-83],-31
	jz L58
X29:
	cmp [X-84],0
	jnz X30
	cmp [X-83],-29
	jz L53
X30:
	xjmp L47
L85:
	mov A,[X-83]
	sub A,-15
	mov REG[0xd0],>__r0
	mov [__rY],A
	mov A,[X-84]
	xor A,-128
	sbb A,(0 ^ 0x80)
	jc L47
	or A,[__rY]
	jz L54
X31:
L86:
	cmp [X-84],0
	jnz X32
	cmp [X-83],-11
	jz L63
X32:
	xjmp L47
X1:
	.dbline 149
; 				{
L50:
	.dbline 151
; 					case LS_MSK1:
; 						Stop = TRUE;
	mov [X+58],1
	.dbline 152
; 					break;
	xjmp L48
L51:
	.dbline 155
; 
; 					case LS_MSK2:
; 						Stop = TRUE;
	mov [X+58],1
	.dbline 156
; 					break;
	xjmp L48
L52:
	.dbline 159
; 
; 					case LS_MSK3:
; 						Stop = TRUE;
	mov [X+58],1
	.dbline 160
; 					break;
	xjmp L48
L53:
	.dbline 163
; 
; 					case LS_MSK4:
; 						Stop = TRUE;
	mov [X+58],1
	.dbline 164
; 					break;
	xjmp L48
L54:
	.dbline 167
; 
; 					case LS_MSK5:
; 						Stop = TRUE;
	mov [X+58],1
	.dbline 168
; 					break;
	xjmp L48
L55:
	.dbline 171
; 
; 					case LS_MSK6:
; 						Stop = TRUE;
	mov [X+58],1
	.dbline 172
; 					break;
	xjmp L48
L56:
	.dbline 175
; 
; 					case LS_MSK7:
; 						Stop = TRUE;
	mov [X+58],1
	.dbline 176
; 					break;
	xjmp L48
L57:
	.dbline 179
; 
; 					case LS_MSK8:
; 						Stop = TRUE;
	mov [X+58],1
	.dbline 180
; 					break;
	xjmp L48
L58:
	.dbline 183
; 
; 					case LS_MSK9:
; 						Stop = TRUE;
	mov [X+58],1
	.dbline 184
; 					break;
	xjmp L48
L59:
	.dbline 187
; 
; 					case LS_MSK10:
; 						Stop = TRUE;
	mov [X+58],1
	.dbline 188
; 					break;
	xjmp L48
L60:
	.dbline 191
; 
; 					case LS_MSK11:
; 						Stop = TRUE;
	mov [X+58],1
	.dbline 192
; 					break;
	xjmp L48
L61:
	.dbline 195
; 
; 					case LS_MSK12:
; 						Stop = TRUE;
	mov [X+58],1
	.dbline 196
; 					break;
	xjmp L48
L62:
	.dbline 199
; 
; 					case LS_MSK13:
; 						Stop = TRUE;
	mov [X+58],1
	.dbline 200
; 					break;
	xjmp L48
L63:
	.dbline 203
; 
; 					case LS_MSK14:
; 						Stop = TRUE;
	mov [X+58],1
	.dbline 204
; 					break;
	xjmp L48
L64:
	.dbline 207
; 
; 					case LS_MSK15:
; 						Stop = TRUE;
	mov [X+58],1
	.dbline 208
; 					break;
	xjmp L48
L65:
	.dbline 211
; 
; 					case LS_MSK16:
; 						Stop = TRUE;
	mov [X+58],1
	.dbline 212
; 					break;
	xjmp L48
L66:
	.dbline 215
; 
; 					case LS_MSK17:
; 						Stop = TRUE;
	mov [X+58],1
	.dbline 216
; 					break;
	xjmp L48
L67:
	.dbline 219
; 
; 					case LS_MSK18:
; 						Stop = TRUE;
	mov [X+58],1
	.dbline 220
; 					break;
	xjmp L48
L68:
	.dbline 223
; 
; 					case IS_LN_MSK:
; 						Stop = TRUE;
	mov [X+58],1
	.dbline 224
; 					break;
	xjmp L48
L47:
	.dbline 227
; 
; 					default:
; 						LS_Mask = (PRT2DR & IS_LN_MSK);
	mov A,REG[0x8]
	mov REG[0xd0],>__r0
	and A,1
	mov [X+1],A
	.dbline 228
; 						if (!LS_Mask)
	cmp [X+1],0
	jnz L69
	.dbline 229
; 						{
	.dbline 230
; 							Stop = TRUE;
	mov [X+58],1
	.dbline 231
; 						}
	xjmp L70
L69:
	.dbline 234
; 
; 						else
; 						{
	.dbline 235
; 							Stop = FALSE;
	mov [X+58],0
	.dbline 236
; 						}
L70:
	.dbline 237
; 				}
L48:
	.dbline 238
; 			}
L44:
L30:
	.dbline 240
; 			
; 			if ((PSoC_Select) && (Command.Velocity > 0) && (CmdRxByte & MTYPE))
	cmp [X+56],0
	jz L87
	mov A,0
	sub A,[X+7]
	mov A,[X+6]
	xor A,-128
	mov REG[0xd0],>__r0
	mov [__rX],A
	mov A,(0 ^ 0x80)
	sbb A,[__rX]
	jnc L87
X33:
	tst [X+57],32
	jz L87
	.dbline 241
; 			{
	.dbline 242
; 				LS_Mask = (PRT2DR | IS_LN_MSK);
	mov A,REG[0x8]
	mov REG[0xd0],>__r0
	mov [__r0],A
	or [__r0],1
	mov A,[__r0]
	mov [X+1],A
	.dbline 244
; 
; 				switch (LS_Mask)
	mov A,[X+1]
	mov [X-83],A
	mov [X-84],0
	cmp [X-84],0
	jnz X34
	cmp [X-83],1
	jz L93
X34:
	xjmp L90
X2:
	.dbline 245
; 				{
L93:
	.dbline 247
; 					case IS_LN_MSK:
; 						Stop = TRUE;
	mov [X+58],1
	.dbline 248
; 					break;
	xjmp L91
L90:
	.dbline 251
; 
; 					default:
; 						Stop = FALSE;
	mov [X+58],0
	.dbline 252
; 				}
L91:
	.dbline 253
; 			}
L87:
	.dbline 255
; 
; 			if ((PSoC_Select && Stop) || (PSoC_Select && Command.Velocity == 0))
	cmp [X+56],0
	jz L98
	cmp [X+58],0
	jnz L97
L98:
	cmp [X+56],0
	jz L94
	cmp [X+6],0
	jnz L94
	cmp [X+7],0
	jnz L94
X35:
L97:
	.dbline 256
; 			{
	.dbline 257
; 				StopMotor(BOTH);
	mov A,0
	push A
	mov A,2
	push A
	xcall _StopMotor
	add SP,-2
	.dbline 259
; 
; 	       		Command.Velocity = 0;
	mov [X+7],0
	mov [X+6],0
	.dbline 260
; 	       		Command.VP6 = 0;
	mov [X+18],0
	mov [X+17],0
	.dbline 261
; 	   			Command.VP5 = 0;
	mov [X+20],0
	mov [X+19],0
	.dbline 262
; 	   			Command.VP4 = 0;
	mov [X+22],0
	mov [X+21],0
	.dbline 263
; 	   			Command.VP3 = 0;
	mov [X+24],0
	mov [X+23],0
	.dbline 264
; 	   			Command.VP2 = 0;
	mov [X+26],0
	mov [X+25],0
	.dbline 265
; 	   			Command.VP1 = 0;
	mov [X+28],0
	mov [X+27],0
	.dbline 266
; 	   			Command.VS1 = 0;
	mov [X+30],0
	mov [X+29],0
	.dbline 267
; 	   			Command.VS2 = 0;
	mov [X+32],0
	mov [X+31],0
	.dbline 268
; 	   			Command.VS3 = 0;
	mov [X+34],0
	mov [X+33],0
	.dbline 269
; 	   			Command.VS4 = 0;
	mov [X+36],0
	mov [X+35],0
	.dbline 270
; 	   			Command.VS5 = 0;
	mov [X+38],0
	mov [X+37],0
	.dbline 271
; 	   			Command.VS6 = 0;
	mov [X+40],0
	mov [X+39],0
	.dbline 273
; 
; 	       		if (Stop)
	cmp [X+58],0
	jz L112
	.dbline 274
; 	       		{
	.dbline 275
; 	       			StsTxByte |= PSOCSTOP;
	mov REG[0xd0],>__r0
	mov A,[X+60]
	or A,8
	mov [X+60],A
	.dbline 276
; 	       			Stop = FALSE;
	mov [X+58],0
	.dbline 277
; 	       		}
L112:
	.dbline 279
; 
; 	       		if (Command.PrevOffline)
	cmp [X+14],0
	jz L114
	.dbline 280
; 	       		{
	.dbline 282
; 
; 	       			StsTxByte |= LINELEFT;
	mov REG[0xd0],>__r0
	mov A,[X+60]
	or A,16
	mov [X+60],A
	.dbline 283
; 	       		}
	xjmp L115
L114:
	.dbline 286
; 
; 	       		else
; 	       		{
	.dbline 287
; 	       			StsTxByte &= LINERIGHT;
	and [X+60],-17
	.dbline 288
; 	       		}
L115:
	.dbline 290
; 
; 	       		if (Command.Center)
	cmp [X+15],0
	jz L117
	.dbline 291
; 	       		{
	.dbline 292
; 	       			StsTxByte |= CENTER;
	mov REG[0xd0],>__r0
	mov A,[X+60]
	or A,32
	mov [X+60],A
	.dbline 293
; 	       		}
	xjmp L118
L117:
	.dbline 296
; 	       		
; 	       		else
; 	       		{
	.dbline 297
; 	       			StsTxByte &= NOTCENTER;
	and [X+60],-33
	.dbline 298
; 	       		}
L118:
	.dbline 300
; 
; 	       		if (PSoC_Select)
	cmp [X+56],0
	jz L120
	.dbline 301
; 	       		{
	.dbline 302
; 	       			TX8_1_SendData(StsTxByte);
	push X
	mov A,[X+60]
	xcall _TX8_1_SendData
	.dbline 303
; 	       			TX8_2_SendData(0x94);
	mov A,-108
	xcall _TX8_2_SendData
	pop X
	.dbline 304
; 					TX8_2_PutString(blank);
	mov REG[0xd0],>__r0
	mov [__r1],X
	add [__r1],-118
	push X
	mov A,7
	push A
	mov A,[__r1]
	mov X,A
	pop A
	xcall _TX8_2_PutString
	.dbline 305
; 					TX8_2_SendData(0x94);
	mov A,-108
	xcall _TX8_2_SendData
	pop X
	.dbline 306
; 					TX8_2_PutSHexByte(StsTxByte);
	push X
	mov A,[X+60]
	xcall _TX8_2_PutSHexByte
	pop X
	.dbline 307
; 					Weigh = FALSE;
	mov [X-119],0
	.dbline 308
; 					PSoC_Select = FALSE;
	mov [X+56],0
	.dbline 309
; 	       		}
L120:
	.dbline 311
; 
; 				if (bTxStatus = bTX8_1_ReadTxStatus() & TX8_1_TX_COMPLETE)
	push X
	xcall _bTX8_1_ReadTxStatus
	mov REG[0xd0],>__r0
	pop X
	mov [__r0],A
	and [__r0],32
	mov A,[__r0]
	mov [X+80],A
	cmp [__r0],0
	jz L122
	.dbline 312
; 				{
	.dbline 313
; 					TX8_1_Stop();
	push X
	xcall _TX8_1_Stop
	pop X
	.dbline 314
; 					bTxStatus = 0;
	mov [X+80],0
	.dbline 315
; 				}
L122:
	.dbline 316
; 			}
L94:
	.dbline 318
; 			 
; 			loopcnt = 0;
	mov [X+62],0
	mov [X+61],0
	.dbline 320
; 				 
; 			LS_Mask = (PRT2DR | IS_LN_MSK);
	mov A,REG[0x8]
	mov REG[0xd0],>__r0
	mov [__r0],A
	or [__r0],1
	mov A,[__r0]
	mov [X+1],A
	.dbline 321
; 			LS_Mask = ~LS_Mask;
	mov A,[X+1]
	cpl A
	mov [X+1],A
	.dbline 322
; 			cnt = 3;
	mov [X+3],3
	mov [X+2],0
	.dbline 323
; 			R_LS_Mask = LS_Mask >> 4;
	mov A,[X+1]
	asr A
	asr A
	asr A
	asr A
	and A,15
	mov [X+59],A
	.dbline 324
; 			L_LS_Mask = 0;
	mov [X+4],0
	xjmp L125
L124:
	.dbline 327
	.dbline 328
	mov [X+0],0
	.dbline 329
	and F,-5
	rrc [X+1]
	.dbline 330
	mov A,[X+1]
	and A,1
	mov [X+0],A
	.dbline 331
	mov REG[0xd0],>__r0
	mov [__r0],7
	mov [__r1],X
	add [__r1],48
	mov A,[X+3]
	mov [__r3],A
	mov A,[X+2]
	mov [__r2],A
	asl [__r3]
	rlc [__r2]
	mov A,[__r3]
	add A,[__r1]
	mov [__r1],A
	mov A,[__r2]
	adc A,[__r0]
	mov REG[0xd4],A
	mvi A,[__r1]
	mov [__r0],A
	mvi A,[__r1]
	mov [__r1],A
	mov A,[X+0]
	mov [__r3],A
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	mov A,0
	push A
	mov A,[__r3]
	push A
	xcall __mul16
	add SP,-4
	mov A,[__rX]
	mov [X+0],A
	.dbline 332
	mov A,[X+4]
	or A,[X+0]
	mov [X+4],A
	.dbline 333
	dec [X+3]
	sbb [X+2],0
	.dbline 334
L125:
	.dbline 326
; 				
; 			while(cnt >= 0)
	mov A,[X+3]
	sub A,0
	mov A,[X+2]
	xor A,-128
	sbb A,(0 ^ 0x80)
	jnc L124
X36:
	.dbline 336
; 			{
; 				Mask = 0;
; 				LS_Mask = LS_Mask >> 1;
; 				Mask = (LS_Mask & IS_LN_MSK);
; 				Mask = Mask * pwr[cnt];
; 				L_LS_Mask = (L_LS_Mask | Mask);
; 				cnt--;
; 			}				
; 			
; 			Command.PrevOffline = Command.Offline;
	mov A,[X+13]
	mov [X+14],A
	.dbline 338
; 			
; 			if (R_LS_Mask < L_LS_Mask)
	mov A,[X+59]
	cmp A,[X+4]
	jnc L129
X37:
	.dbline 339
; 			{
	.dbline 340
; 				Command.Offline = LEFT;
	mov [X+13],1
	.dbline 341
; 				Command.Center = FALSE;
	mov [X+15],0
	.dbline 343
; 				
; 				if (L_LS_Mask == 8)
	cmp [X+4],8
	jnz L133
	.dbline 344
; 				{
	.dbline 345
; 					Command.END_SENSOR = TRUE;
	mov [X+16],1
	.dbline 346
; 				}
	xjmp L130
L133:
	.dbline 349
; 				
; 				else
; 				{
	.dbline 350
; 					Command.END_SENSOR = FALSE;
	mov [X+16],0
	.dbline 351
; 				}
	.dbline 352
; 			}
	xjmp L130
L129:
	.dbline 354
; 			
; 			else if (R_LS_Mask > L_LS_Mask)
	mov A,[X+4]
	cmp A,[X+59]
	jnc L137
X38:
	.dbline 355
; 			{
	.dbline 356
; 				Command.Offline = RIGHT;
	mov [X+13],0
	.dbline 357
; 				Command.Center = FALSE;
	mov [X+15],0
	.dbline 359
; 				
; 				if (R_LS_Mask == 8)
	cmp [X+59],8
	jnz L141
	.dbline 360
; 				{
	.dbline 361
; 					Command.END_SENSOR = TRUE;
	mov [X+16],1
	.dbline 362
; 				}
	xjmp L138
L141:
	.dbline 365
; 				
; 				else
; 				{
	.dbline 366
; 					Command.END_SENSOR = FALSE;
	mov [X+16],0
	.dbline 367
; 				}
	.dbline 368
; 			}
	xjmp L138
L137:
	.dbline 371
; 			
; 			else
; 			{
	.dbline 372
; 				if (!Command.END_SENSOR)
	cmp [X+16],0
	jnz L145
	.dbline 373
; 				{
	.dbline 374
; 					Command.Center = TRUE;
	mov [X+15],1
	.dbline 375
; 				}
L145:
	.dbline 376
; 			}
L138:
L130:
	.dbline 377
; 		}// end 10 ms timeslot
L18:
	.dbline 382
; 
; //
; // Do this every 20 ms
; //
; 		if (TimeSlot & 4)
	mov REG[0xd0],>_TimeSlot
	mov A,[_TimeSlot+1]
	and A,4
	mov REG[0xd0],>__r0
	mov [__r1],A
	mov REG[0xd0],>_TimeSlot
	mov A,[_TimeSlot]
	and A,0
	mov REG[0xd0],>__r0
	cmp A,0
	jnz X39
	cmp [__r1],0
	jz L149
X39:
	.dbline 383
; 		{
	.dbline 384
; 			TimeSlot ^= 4;
	mov REG[0xd0],>_TimeSlot
	xor [_TimeSlot+1],4
	xor [_TimeSlot],0
	.dbline 386
; 
; 		}// end 20 ms timeslot
L149:
	.dbline 390
; 
; // Do this every 40 ms (the sample period is 40 ms)
; 
; 		if (TimeSlot & 8)
	mov REG[0xd0],>_TimeSlot
	mov A,[_TimeSlot+1]
	and A,8
	mov REG[0xd0],>__r0
	mov [__r1],A
	mov REG[0xd0],>_TimeSlot
	mov A,[_TimeSlot]
	and A,0
	mov REG[0xd0],>__r0
	cmp A,0
	jnz X40
	cmp [__r1],0
	jz L151
X40:
	.dbline 391
; 		{
	.dbline 392
; 			TimeSlot ^= 8;
	mov REG[0xd0],>_TimeSlot
	xor [_TimeSlot+1],8
	xor [_TimeSlot],0
	.dbline 394
; 
; 			if (PSoC_Select)
	cmp [X+56],0
	jz L153
	.dbline 395
; 			{
	.dbline 396
; 				ControlWheel(&Command, &WestWheel, &WestPID);
	mov REG[0xd0],>__r0
	mov [__r1],X
	add [__r1],81
	mov A,7
	push A
	mov A,[__r1]
	push A
	mov [__r1],X
	add [__r1],72
	mov A,7
	push A
	mov A,[__r1]
	push A
	mov [__r1],X
	add [__r1],5
	mov A,7
	push A
	mov A,[__r1]
	push A
	xcall _ControlWheel
	.dbline 397
; 				ControlWheel(&Command, &EastWheel, &EastPID);
	mov REG[0xd0],>__r0
	mov [__r1],X
	add [__r1],109
	mov A,7
	push A
	mov A,[__r1]
	push A
	mov [__r1],X
	add [__r1],64
	mov A,7
	push A
	mov A,[__r1]
	push A
	mov [__r1],X
	add [__r1],5
	mov A,7
	push A
	mov A,[__r1]
	push A
	xcall _ControlWheel
	add SP,-12
	.dbline 398
; 			}
L153:
	.dbline 400
; 
; 		}// end 40 ms timeslot
L151:
	.dbline 404
; 
; // Do this every 160 ms
; 
; 		if (TimeSlot & 32)
	mov REG[0xd0],>_TimeSlot
	mov A,[_TimeSlot+1]
	and A,32
	mov REG[0xd0],>__r0
	mov [__r1],A
	mov REG[0xd0],>_TimeSlot
	mov A,[_TimeSlot]
	and A,0
	mov REG[0xd0],>__r0
	cmp A,0
	jnz X41
	cmp [__r1],0
	jz L155
X41:
	.dbline 405
; 		{
	.dbline 406
; 			TimeSlot ^= 32;
	mov REG[0xd0],>_TimeSlot
	xor [_TimeSlot+1],32
	xor [_TimeSlot],0
	.dbline 407
; 		}// end 160 ms timeslot
L155:
	.dbline 411
; 
; // Update the LCD screen once each 1.28 seconds
; 
; 		if (TimeSlot & 256)
	mov REG[0xd0],>_TimeSlot
	mov A,[_TimeSlot+1]
	and A,0
	mov REG[0xd0],>__r0
	mov [__r1],A
	mov REG[0xd0],>_TimeSlot
	mov A,[_TimeSlot]
	and A,1
	mov REG[0xd0],>__r0
	cmp A,0
	jnz X42
	cmp [__r1],0
	jz L157
X42:
	.dbline 412
; 		{
	.dbline 413
; 			TimeSlot ^= 256;
	mov REG[0xd0],>_TimeSlot
	xor [_TimeSlot+1],0
	xor [_TimeSlot],1
	.dbline 415
; 
; 		}// end 1280 ms timeslot
L157:
	.dbline 416
L16:
	.dbline 74
	xjmp L15
X3:
	.dbline -2
	.dbline 417
; 	}// end while loop
; }// end of main program
L4:
	add SP,-174
	pop X
	.dbline 0 ; func end
	jmp .
	.dbsym l str 155 A[17:17]c
	.dbsym l blank 138 A[17:17]c
	.dbsym l Weigh 137 c
	.dbsym l EastPID 109 X
	.dbsym l WestPID 81 X
	.dbsym l bTxStatus 80 c
	.dbsym l WestWheel 72 X
	.dbsym l EastWheel 64 X
	.dbsym l bRxStatus 63 c
	.dbsym l loopcnt 61 I
	.dbsym l StsTxByte 60 c
	.dbsym l R_LS_Mask 59 c
	.dbsym l Stop 58 c
	.dbsym l CmdRxByte 57 c
	.dbsym l PSoC_Select 56 c
	.dbsym l pwr 48 A[8:4]I
	.dbsym l Command 5 X
	.dbsym l L_LS_Mask 4 c
	.dbsym l cnt 2 I
	.dbsym l LS_Mask 1 c
	.dbsym l Mask 0 c
	.dbend
	.dbfunc e Timer16_1_ISR _Timer16_1_ISR fV
;           temp -> X+0
_Timer16_1_ISR::
	.dbline -1
	or F,-64
	push A
	mov A,REG[0xd0]
	push A
	mov REG[0xd0],>__r0
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	push X
	mov X,SP
	add SP,2
	.dbline 428
; 
; 
; 
; ////////////////////////////////////////////////////////////////////////
; 
; // Timer interrupt routine (every 5 ms)
; #pragma interrupt_handler Timer16_1_ISR
; #pragma nomac
; 
; void Timer16_1_ISR()
; {
	.dbline 431
; 	int temp;
; 
; 	temp = SliceCounter++;
	mov REG[0xd0],>_SliceCounter
	mov A,[_SliceCounter+1]
	push A
	mov A,[_SliceCounter]
	mov REG[0xd0],>__r0
	mov [__r0],A
	pop A
	mov [__r1],A
	add A,1
	mov REG[0xd0],>_SliceCounter
	mov [_SliceCounter+1],A
	mov REG[0xd0],>__r0
	mov A,[__r0]
	adc A,0
	mov REG[0xd0],>_SliceCounter
	mov [_SliceCounter],A
	mov REG[0xd0],>__r0
	mov A,[__r1]
	mov [X+1],A
	mov A,[__r0]
	mov [X+0],A
	.dbline 432
; 	TimeSlot |= ((temp ^ SliceCounter) + 1);
	mov REG[0xd0],>_SliceCounter
	mov A,[X+1]
	xor A,[_SliceCounter+1]
	mov REG[0xd0],>__r0
	mov [__r1],A
	mov A,[X+0]
	mov REG[0xd0],>_SliceCounter
	xor A,[_SliceCounter]
	mov REG[0xd0],>__r0
	mov [__r0],A
	add [__r1],1
	adc [__r0],0
	mov A,[__r1]
	mov REG[0xd0],>_TimeSlot
	or [_TimeSlot+1],A
	mov REG[0xd0],>__r0
	mov A,[__r0]
	mov REG[0xd0],>_TimeSlot
	or [_TimeSlot],A
	.dbline -2
	.dbline 433
; }
L159:
	add SP,-2
	pop X
	mov REG[0xD0],>__r0
	pop A
	mov [__r1],A
	pop A
	mov [__r0],A
	pop A
	mov REG[208],A
	pop A
	.dbline 0 ; func end
	reti
	.dbsym l temp 0 I
	.dbend
